searchData={"items":[{"type":"module","title":"Modbux.Helper","doc":"Binary helper module","ref":"Modbux.Helper.html"},{"type":"function","title":"Modbux.Helper.bin_to_bitlist/2","doc":"","ref":"Modbux.Helper.html#bin_to_bitlist/2"},{"type":"function","title":"Modbux.Helper.bin_to_reglist/2","doc":"","ref":"Modbux.Helper.html#bin_to_reglist/2"},{"type":"function","title":"Modbux.Helper.bitlist_to_bin/1","doc":"","ref":"Modbux.Helper.html#bitlist_to_bin/1"},{"type":"function","title":"Modbux.Helper.bool_to_byte/1","doc":"","ref":"Modbux.Helper.html#bool_to_byte/1"},{"type":"function","title":"Modbux.Helper.byte_count/1","doc":"","ref":"Modbux.Helper.html#byte_count/1"},{"type":"function","title":"Modbux.Helper.crc/1","doc":"","ref":"Modbux.Helper.html#crc/1"},{"type":"function","title":"Modbux.Helper.reglist_to_bin/1","doc":"","ref":"Modbux.Helper.html#reglist_to_bin/1"},{"type":"module","title":"Modbux.IEEE754","doc":"IEEE754 float helper\n\nBased on https://www.h-schmidt.net/FloatConverter/IEEE754.html.","ref":"Modbux.IEEE754.html"},{"type":"function","title":"Modbux.IEEE754.from_2_regs/2","doc":"Converts a couple of 16-bit registers to IEEE754 float.","ref":"Modbux.IEEE754.html#from_2_regs/2"},{"type":"function","title":"Example - Modbux.IEEE754.from_2_regs/2","doc":"```elixir\n+5.0 = IEEE754.from_2_regs(0x40a0, 0x0000, :be)\n```","ref":"Modbux.IEEE754.html#from_2_regs/2-example"},{"type":"function","title":"Modbux.IEEE754.from_2_regs/3","doc":"Converts a couple of 16-bit registers to IEEE754 float.","ref":"Modbux.IEEE754.html#from_2_regs/3"},{"type":"function","title":"Example - Modbux.IEEE754.from_2_regs/3","doc":"```elixir\n+5.0 = IEEE754.from_2_regs(0x40a0, 0x0000, :be)\n```","ref":"Modbux.IEEE754.html#from_2_regs/3-example"},{"type":"function","title":"Modbux.IEEE754.from_2n_regs/2","doc":"Converts a list of 2n 16-bit registers to a IEEE754 floats list.","ref":"Modbux.IEEE754.html#from_2n_regs/2"},{"type":"function","title":"Example - Modbux.IEEE754.from_2n_regs/2","doc":"```elixir\n[-5.0, +5.0] = IEEE754.from_2n_regs([0xc0a0, 0x0000, 0x40a0, 0x0000], :be)\n```","ref":"Modbux.IEEE754.html#from_2n_regs/2-example"},{"type":"function","title":"Modbux.IEEE754.to_2_regs/2","doc":"Converts a IEEE754 float to a couple of 16-bit registers.","ref":"Modbux.IEEE754.html#to_2_regs/2"},{"type":"function","title":"Example - Modbux.IEEE754.to_2_regs/2","doc":"```elixir\n[0xc0a0, 0x0000] = IEEE754.to_2_regs(-5.0)\n```","ref":"Modbux.IEEE754.html#to_2_regs/2-example"},{"type":"function","title":"Modbux.IEEE754.to_2n_regs/2","doc":"Converts a list of IEEE754 floats to a list of 2n 16-bit registers.","ref":"Modbux.IEEE754.html#to_2n_regs/2"},{"type":"function","title":"Example - Modbux.IEEE754.to_2n_regs/2","doc":"```elixir\n[0xc0a0, 0x0000, 0x40a0, 0x0000] = IEEE754.to_2n_regs([-5.0, +5.0])\n```","ref":"Modbux.IEEE754.html#to_2n_regs/2-example"},{"type":"module","title":"Modbux.Model","doc":"Model helper, functions to write and read the Slave/Server DB.","ref":"Modbux.Model.html"},{"type":"function","title":"Modbux.Model.apply/2","doc":"","ref":"Modbux.Model.html#apply/2"},{"type":"function","title":"Modbux.Model.reads/2","doc":"","ref":"Modbux.Model.html#reads/2"},{"type":"function","title":"Modbux.Model.write/2","doc":"","ref":"Modbux.Model.html#write/2"},{"type":"function","title":"Modbux.Model.writes/2","doc":"","ref":"Modbux.Model.html#writes/2"},{"type":"module","title":"Modbux.Model.Shared","doc":"An agent that holds the current state of the Server/Slave DB.","ref":"Modbux.Model.Shared.html"},{"type":"function","title":"Modbux.Model.Shared.apply/2","doc":"","ref":"Modbux.Model.Shared.html#apply/2"},{"type":"function","title":"Modbux.Model.Shared.start_link/2","doc":"","ref":"Modbux.Model.Shared.html#start_link/2"},{"type":"function","title":"Modbux.Model.Shared.state/1","doc":"","ref":"Modbux.Model.Shared.html#state/1"},{"type":"function","title":"Modbux.Model.Shared.stop/1","doc":"","ref":"Modbux.Model.Shared.html#stop/1"},{"type":"module","title":"Modbux.Request","doc":"Request helper, functions that handles Client & Master request messages.","ref":"Modbux.Request.html"},{"type":"function","title":"Modbux.Request.length/1","doc":"","ref":"Modbux.Request.html#length/1"},{"type":"function","title":"Modbux.Request.pack/1","doc":"","ref":"Modbux.Request.html#pack/1"},{"type":"function","title":"Modbux.Request.parse/1","doc":"","ref":"Modbux.Request.html#parse/1"},{"type":"module","title":"Modbux.Response","doc":"Response helper, functions that handles Server & Slave response messages.","ref":"Modbux.Response.html"},{"type":"function","title":"Modbux.Response.length/1","doc":"","ref":"Modbux.Response.html#length/1"},{"type":"function","title":"Modbux.Response.pack/2","doc":"","ref":"Modbux.Response.html#pack/2"},{"type":"function","title":"Modbux.Response.parse/2","doc":"","ref":"Modbux.Response.html#parse/2"},{"type":"module","title":"Modbux.Rtu","doc":"RTU message helper, functions that handles RTU responses/requests messages.","ref":"Modbux.Rtu.html"},{"type":"function","title":"Modbux.Rtu.pack_req/1","doc":"","ref":"Modbux.Rtu.html#pack_req/1"},{"type":"function","title":"Modbux.Rtu.pack_res/1","doc":"","ref":"Modbux.Rtu.html#pack_res/1"},{"type":"function","title":"Modbux.Rtu.pack_res/2","doc":"","ref":"Modbux.Rtu.html#pack_res/2"},{"type":"function","title":"Modbux.Rtu.parse_req/1","doc":"","ref":"Modbux.Rtu.html#parse_req/1"},{"type":"function","title":"Modbux.Rtu.parse_res/2","doc":"","ref":"Modbux.Rtu.html#parse_res/2"},{"type":"function","title":"Modbux.Rtu.req_len/1","doc":"","ref":"Modbux.Rtu.html#req_len/1"},{"type":"function","title":"Modbux.Rtu.res_len/1","doc":"","ref":"Modbux.Rtu.html#res_len/1"},{"type":"function","title":"Modbux.Rtu.unwrap/1","doc":"","ref":"Modbux.Rtu.html#unwrap/1"},{"type":"function","title":"Modbux.Rtu.wrap/1","doc":"","ref":"Modbux.Rtu.html#wrap/1"},{"type":"module","title":"Modbux.Rtu.Framer","doc":"A framer for Modbus RTU frames. This framer doesn't do anything for the transmit\ndirection, but for receives, it will collect bytes that follows the Modbus RTU protocol,\nit also execute the CRC validation and returns the frame or the error.","ref":"Modbux.Rtu.Framer.html"},{"type":"function","title":"Modbux.Rtu.Framer.add_framing/2","doc":"","ref":"Modbux.Rtu.Framer.html#add_framing/2"},{"type":"function","title":"Modbux.Rtu.Framer.buffer_empty?/1","doc":"","ref":"Modbux.Rtu.Framer.html#buffer_empty?/1"},{"type":"function","title":"Modbux.Rtu.Framer.flush/2","doc":"","ref":"Modbux.Rtu.Framer.html#flush/2"},{"type":"function","title":"Modbux.Rtu.Framer.frame_timeout/1","doc":"","ref":"Modbux.Rtu.Framer.html#frame_timeout/1"},{"type":"function","title":"Modbux.Rtu.Framer.init/1","doc":"","ref":"Modbux.Rtu.Framer.html#init/1"},{"type":"function","title":"Modbux.Rtu.Framer.remove_framing/2","doc":"","ref":"Modbux.Rtu.Framer.html#remove_framing/2"},{"type":"module","title":"Modbux.Tcp","doc":"Tcp message helper, functions that handles TCP responses/requests messages.","ref":"Modbux.Tcp.html"},{"type":"function","title":"Modbux.Tcp.pack_req/2","doc":"","ref":"Modbux.Tcp.html#pack_req/2"},{"type":"function","title":"Modbux.Tcp.pack_res/3","doc":"","ref":"Modbux.Tcp.html#pack_res/3"},{"type":"function","title":"Modbux.Tcp.parse_req/1","doc":"","ref":"Modbux.Tcp.html#parse_req/1"},{"type":"function","title":"Modbux.Tcp.parse_res/3","doc":"","ref":"Modbux.Tcp.html#parse_res/3"},{"type":"function","title":"Modbux.Tcp.req_len/1","doc":"","ref":"Modbux.Tcp.html#req_len/1"},{"type":"function","title":"Modbux.Tcp.res_len/1","doc":"","ref":"Modbux.Tcp.html#res_len/1"},{"type":"function","title":"Modbux.Tcp.unwrap/1","doc":"","ref":"Modbux.Tcp.html#unwrap/1"},{"type":"function","title":"Modbux.Tcp.unwrap/2","doc":"","ref":"Modbux.Tcp.html#unwrap/2"},{"type":"function","title":"Modbux.Tcp.wrap/2","doc":"","ref":"Modbux.Tcp.html#wrap/2"},{"type":"module","title":"Modbux.Tcp.Server.Handler","doc":"A worker for each Modbus Client, handles Client requests.","ref":"Modbux.Tcp.Server.Handler.html"},{"type":"function","title":"Modbux.Tcp.Server.Handler.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Modbux.Tcp.Server.Handler.html#child_spec/1"},{"type":"function","title":"Modbux.Tcp.Server.Handler.init/1","doc":"","ref":"Modbux.Tcp.Server.Handler.html#init/1"},{"type":"function","title":"Modbux.Tcp.Server.Handler.start_link/1","doc":"","ref":"Modbux.Tcp.Server.Handler.html#start_link/1"},{"type":"module","title":"Modbux.Tcp.Server.Supervisor","doc":"Spawns and supervises each Modbus Client handler.","ref":"Modbux.Tcp.Server.Supervisor.html"},{"type":"function","title":"Modbux.Tcp.Server.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Modbux.Tcp.Server.Supervisor.html#child_spec/1"},{"type":"function","title":"Modbux.Tcp.Server.Supervisor.init/1","doc":"","ref":"Modbux.Tcp.Server.Supervisor.html#init/1"},{"type":"function","title":"Modbux.Tcp.Server.Supervisor.start_child/3","doc":"","ref":"Modbux.Tcp.Server.Supervisor.html#start_child/3"},{"type":"function","title":"Modbux.Tcp.Server.Supervisor.start_link/1","doc":"","ref":"Modbux.Tcp.Server.Supervisor.html#start_link/1"},{"type":"module","title":"Modbux.Rtu.Master","doc":"API for a Modbus RTU Master device.","ref":"Modbux.Rtu.Master.html"},{"type":"function","title":"Modbux.Rtu.Master.async_uart_read/2","doc":"","ref":"Modbux.Rtu.Master.html#async_uart_read/2"},{"type":"function","title":"Modbux.Rtu.Master.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Modbux.Rtu.Master.html#child_spec/1"},{"type":"function","title":"Modbux.Rtu.Master.close/1","doc":"Close the Master serial port.","ref":"Modbux.Rtu.Master.html#close/1"},{"type":"function","title":"Modbux.Rtu.Master.configure/2","doc":"Configure the Master serial port.\n\nThe following options are available:\n\n  * `tty` - defines the serial port to spawn the Master.\n  * `timeout` - defines slave timeout.\n  * `active` - (`true` or `false`) specifies whether data is received as\n      messages (mailbox) or by calling `request/2`.\n  * `gen_opts` - defines extra options for the Genserver OTP configuration.\n  * `uart_opts` - defines extra options for the UART configuration.","ref":"Modbux.Rtu.Master.html#configure/2"},{"type":"function","title":"Modbux.Rtu.Master.init/1","doc":"","ref":"Modbux.Rtu.Master.html#init/1"},{"type":"function","title":"Modbux.Rtu.Master.open/1","doc":"Open the Master serial port.","ref":"Modbux.Rtu.Master.html#open/1"},{"type":"function","title":"Modbux.Rtu.Master.read/1","doc":"Read and parse the last request (if the last request timeouts).","ref":"Modbux.Rtu.Master.html#read/1"},{"type":"function","title":"Modbux.Rtu.Master.request/2","doc":"Send a request to Modbus RTU Slave.\n\n`cmd` is one of:\n  - `{:rc, slave, address, count}` read `count` coils.\n  - `{:ri, slave, address, count}` read `count` inputs.\n  - `{:rhr, slave, address, count}` read `count` holding registers.\n  - `{:rir, slave, address, count}` read `count` input registers.\n  - `{:fc, slave, address, value}` force single coil.\n  - `{:phr, slave, address, value}` preset single holding register.\n  - `{:fc, slave, address, values}` force multiple coils.\n  - `{:phr, slave, address, values}` preset multiple holding registers.","ref":"Modbux.Rtu.Master.html#request/2"},{"type":"function","title":"Modbux.Rtu.Master.start_link/1","doc":"Starts a Modbus RTU Master process.\n\nThe following options are available:\n\n  * `tty` - defines the serial port to spawn the Master.\n  * `timeout` - defines slave timeout.\n  * `active` - (`true` or `false`) specifies whether data is received as\n      messages (mailbox) or by calling `request/2`.\n  * `gen_opts` - defines extra options for the Genserver OTP configuration.\n  * `uart_opts` - defines extra options for the UART configuration (defaults:\n        [speed: 115200, rx_framing_timeout: 1000]).\n\nThe messages (when active mode is true) have the following form:\n\n  `{:modbus_rtu, {:slave_response, cmd, values}}`\nor\n\n  `{:modbus_rtu, {:slave_error, payload, reason}}`\n\nThe following are some reasons:\n\n  * `:ecrc`  - corrupted message (invalid crc).\n  * `:einval`  - invalid function.\n  * `:eaddr`  - invalid memory address requested.","ref":"Modbux.Rtu.Master.html#start_link/1"},{"type":"function","title":"Example - Modbux.Rtu.Master.start_link/1","doc":"```elixir\nModbux.Rtu.Master.start_link(tty: \"tnt0\", active: true, uart_opts: [speed: 9600])\n```","ref":"Modbux.Rtu.Master.html#start_link/1-example"},{"type":"function","title":"Modbux.Rtu.Master.state/1","doc":"Gets the Master state.","ref":"Modbux.Rtu.Master.html#state/1"},{"type":"function","title":"Modbux.Rtu.Master.stop/1","doc":"","ref":"Modbux.Rtu.Master.html#stop/1"},{"type":"module","title":"Modbux.Rtu.Slave","doc":"API for a Modbus RTU Slave device.","ref":"Modbux.Rtu.Slave.html"},{"type":"function","title":"Modbux.Rtu.Slave.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Modbux.Rtu.Slave.html#child_spec/1"},{"type":"function","title":"Modbux.Rtu.Slave.get_db/1","doc":"Gets the current state of the Slave DB.","ref":"Modbux.Rtu.Slave.html#get_db/1"},{"type":"function","title":"Modbux.Rtu.Slave.init/1","doc":"","ref":"Modbux.Rtu.Slave.html#init/1"},{"type":"function","title":"Modbux.Rtu.Slave.raw_write/2","doc":"Send a raw frame through the serial port.","ref":"Modbux.Rtu.Slave.html#raw_write/2"},{"type":"function","title":"Modbux.Rtu.Slave.request/2","doc":"Updates the state of the Slave DB.\n\n`cmd` is a 4 elements tuple, as follows:\n  - `{:rc, slave, address, count}` read `count` coils.\n  - `{:ri, slave, address, count}` read `count` inputs.\n  - `{:rhr, slave, address, count}` read `count` holding registers.\n  - `{:rir, slave, address, count}` read `count` input registers.\n  - `{:fc, slave, address, value}` force single coil.\n  - `{:phr, slave, address, value}` preset single holding register.\n  - `{:fc, slave, address, values}` force multiple coils.\n  - `{:phr, slave, address, values}` preset multiple holding registers.","ref":"Modbux.Rtu.Slave.html#request/2"},{"type":"function","title":"Modbux.Rtu.Slave.start_link/1","doc":"Starts a Modbus RTU Slave process.\n\nThe following options are available:\n\n  * `tty` - defines the serial port to spawn the Slave.\n  * `gen_opts` - defines extra options for the Genserver OTP configuration.\n  * `uart_opts` - defines extra options for the UART configuration (defaults:\n        [speed: 115200, rx_framing_timeout: 1000]).\n  * `model` - defines the DB initial state.\n  * `active` - (`true` or `false`) enable/disable DB updates notifications (mailbox).\n\nThe messages (when active mode is true) have the following form:\n\n  `{:modbus_rtu, {:slave_request, payload}}`\n\nor\n\n  `{:modbus_rtu, {:slave_error, payload, reason}}`\n\nThe following are some reasons:\n\n  * `:ecrc`  - corrupted message (invalid crc).\n  * `:einval`  - invalid function.\n  * `:eaddr`  - invalid memory address requested.","ref":"Modbux.Rtu.Slave.html#start_link/1"},{"type":"function","title":"Model (DB) - Modbux.Rtu.Slave.start_link/1","doc":"The model or data base (DB) defines the slave memory map, the DB is defined by the following syntax:\n```elixir\n%{slave_id => %{{memory_type, address_number} => value}}\n```\nwhere:\n  * `slave_id` - specifies a unique unit address from 1 to 247.\n  * `memory_type` - specifies the memory between:\n       * `:c` - Discrete Output Coils.\n       * `:i` - Discrete Input Contacts.\n       * `:ir` - Analog Input Registers.\n       * `:hr` - Analog Output Registers.\n  * `address_number` - specifies the memory address.\n  * `value` - the current value from that memory.","ref":"Modbux.Rtu.Slave.html#start_link/1-model-db"},{"type":"function","title":"Example - Modbux.Rtu.Slave.start_link/1","doc":"```elixir\nmodel = %{80 => %{{:c, 20818} => 0, {:hr, 20818} => 0}}\nModbux.Tcp.Server.start_link(model: model, port: 2000)\n```","ref":"Modbux.Rtu.Slave.html#start_link/1-example"},{"type":"function","title":"Modbux.Rtu.Slave.state/1","doc":"Gets the Slave state.","ref":"Modbux.Rtu.Slave.html#state/1"},{"type":"function","title":"Modbux.Rtu.Slave.stop/1","doc":"","ref":"Modbux.Rtu.Slave.html#stop/1"},{"type":"module","title":"Modbux.Tcp.Client","doc":"API for Modbus TCP Client.","ref":"Modbux.Tcp.Client.html"},{"type":"function","title":"Modbux.Tcp.Client.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Modbux.Tcp.Client.html#child_spec/1"},{"type":"type","title":"Modbux.Tcp.Client.client_option/0","doc":"","ref":"Modbux.Tcp.Client.html#t:client_option/0"},{"type":"function","title":"Modbux.Tcp.Client.close/1","doc":"Close the tcp port of the Client.","ref":"Modbux.Tcp.Client.html#close/1"},{"type":"function","title":"Modbux.Tcp.Client.configure/2","doc":"Configure the Client (`status` must be `:closed`).\n\nThe following options are available:\n\n* `ip` - is the internet address of the desired Modbux TCP Server.\n* `tcp_port` - is the Modbux TCP Server tcp port number .\n* `timeout` - is the connection timeout.\n* `active` - (`true` or `false`) specifies whether data is received as\n     messages (mailbox) or by calling `confirmation/1` each time `request/2` is called.","ref":"Modbux.Tcp.Client.html#configure/2"},{"type":"function","title":"Modbux.Tcp.Client.confirmation/1","doc":"In passive mode (active: false), reads the confirmation of the connected Modbux Server.","ref":"Modbux.Tcp.Client.html#confirmation/1"},{"type":"function","title":"Modbux.Tcp.Client.connect/1","doc":"Connect the Client to a Server.","ref":"Modbux.Tcp.Client.html#connect/1"},{"type":"function","title":"Modbux.Tcp.Client.flush/1","doc":"In passive mode (active: false), flushed the pending messages.","ref":"Modbux.Tcp.Client.html#flush/1"},{"type":"function","title":"Modbux.Tcp.Client.init/1","doc":"","ref":"Modbux.Tcp.Client.html#init/1"},{"type":"function","title":"Modbux.Tcp.Client.request/2","doc":"Send a request to Modbux TCP Server.\n\n`cmd` is a 4 elements tuple, as follows:\n  - `{:rc, slave, address, count}` read `count` coils.\n  - `{:ri, slave, address, count}` read `count` inputs.\n  - `{:rhr, slave, address, count}` read `count` holding registers.\n  - `{:rir, slave, address, count}` read `count` input registers.\n  - `{:fc, slave, address, value}` force single coil.\n  - `{:phr, slave, address, value}` preset single holding register.\n  - `{:fc, slave, address, values}` force multiple coils.\n  - `{:phr, slave, address, values}` preset multiple holding registers.","ref":"Modbux.Tcp.Client.html#request/2"},{"type":"function","title":"Modbux.Tcp.Client.start_link/2","doc":"Starts a Modbus TCP Client process.\n\nThe following options are available:\n\n  * `ip` - is the internet address of the desired Modbux TCP Server.\n  * `tcp_port` - is the desired Modbux TCP Server tcp port number.\n  * `timeout` - is the connection timeout.\n  * `active` - (`true` or `false`) specifies whether data is received as\n      messages (mailbox) or by calling `confirmation/1` each time `request/2` is called.\n\n  The messages (when active mode is true) have the following form:\n\n  `{:modbus_tcp, cmd, values}`","ref":"Modbux.Tcp.Client.html#start_link/2"},{"type":"function","title":"Example - Modbux.Tcp.Client.start_link/2","doc":"```elixir\nModbux.Tcp.Client.start_link(ip: {10,77,0,2}, port: 502, timeout: 2000, active: true)\n```","ref":"Modbux.Tcp.Client.html#start_link/2-example"},{"type":"function","title":"Modbux.Tcp.Client.state/1","doc":"Gets the state of the Client.","ref":"Modbux.Tcp.Client.html#state/1"},{"type":"function","title":"Modbux.Tcp.Client.stop/1","doc":"Stops the Client.","ref":"Modbux.Tcp.Client.html#stop/1"},{"type":"module","title":"Modbux.Tcp.Server","doc":"API for Modbus TCP Server.","ref":"Modbux.Tcp.Server.html"},{"type":"function","title":"Modbux.Tcp.Server.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Modbux.Tcp.Server.html#child_spec/1"},{"type":"function","title":"Modbux.Tcp.Server.close_alive_sockets/1","doc":"","ref":"Modbux.Tcp.Server.html#close_alive_sockets/1"},{"type":"function","title":"Modbux.Tcp.Server.get_db/1","doc":"Gets the current state of the Server DB.","ref":"Modbux.Tcp.Server.html#get_db/1"},{"type":"function","title":"Modbux.Tcp.Server.handle_continue/2","doc":"","ref":"Modbux.Tcp.Server.html#handle_continue/2"},{"type":"function","title":"Modbux.Tcp.Server.init/1","doc":"","ref":"Modbux.Tcp.Server.html#init/1"},{"type":"function","title":"Modbux.Tcp.Server.start_link/2","doc":"Starts a Modbus TCP Server process.\n\nThe following options are available:\n\n  * `port` - is the Modbux TCP Server tcp port number.\n  * `timeout` - is the connection timeout.\n  * `model` - defines the DB initial state.\n  * `sup_otps` - server supervisor OTP options.\n  * `active` - (`true` or `false`) enable/disable DB updates notifications (mailbox).\n\nThe messages (when active mode is true) have the following form:\n\n  `{:modbus_tcp, {:slave_request, payload}}`","ref":"Modbux.Tcp.Server.html#start_link/2"},{"type":"function","title":"Model (DB) - Modbux.Tcp.Server.start_link/2","doc":"The model or data base (DB) defines the server memory map, the DB is defined by the following syntax:\n```elixir\n%{slave_id => %{{memory_type, address_number} => value}}\n```\nwhere:\n  * `slave_id` - specifies a unique unit address from 1 to 247.\n  * `memory_type` - specifies the memory between:\n       * `:c` - Discrete Output Coils.\n       * `:i` - Discrete Input Contacts.\n       * `:ir` - Analog Input Registers.\n       * `:hr` - Analog Output Registers.\n  * `address_number` - specifies the memory address.\n  * `value` - the current value from that memory.","ref":"Modbux.Tcp.Server.html#start_link/2-model-db"},{"type":"function","title":"Example - Modbux.Tcp.Server.start_link/2","doc":"```elixir\nmodel = %{80 => %{{:c, 20818} => 0, {:hr, 20818} => 0}}\nModbux.Tcp.Server.start_link(model: model, port: 2000)\n```","ref":"Modbux.Tcp.Server.html#start_link/2-example"},{"type":"function","title":"Modbux.Tcp.Server.stop/1","doc":"","ref":"Modbux.Tcp.Server.html#stop/1"},{"type":"function","title":"Modbux.Tcp.Server.update/2","doc":"Updates the state of the Server DB.\n\n`cmd` is a 4 elements tuple, as follows:\n  - `{:rc, slave, address, count}` read `count` coils.\n  - `{:ri, slave, address, count}` read `count` inputs.\n  - `{:rhr, slave, address, count}` read `count` holding registers.\n  - `{:rir, slave, address, count}` read `count` input registers.\n  - `{:fc, slave, address, value}` force single coil.\n  - `{:phr, slave, address, value}` preset single holding register.\n  - `{:fc, slave, address, values}` force multiple coils.\n  - `{:phr, slave, address, values}` preset multiple holding registers.","ref":"Modbux.Tcp.Server.html#update/2"},{"type":"extras","title":"README","doc":"***\n \n \n   \n \n \n\nModbux is a library for network and serial Modbus communications. \n\nThis library currently supports behaviors for TCP (Client & Server) and RTU (Master & Slave) protocols.","ref":"readme.html"},{"type":"extras","title":"Index - README","doc":"* [Features](#features)\n\n* [Installation](#installation)\n\n* [Usage](#usage)\n    * [Modbus RTU](#Slave)\n    * [Modbus TCP](#Server)\n    * [Helpers](#Helpers)\n\n* [Documentation](#documentation)\n\n* [Contributing](#contributing)\n\n* [License](#License)\n\n* [TODO](#todo)","ref":"readme.html#index"},{"type":"extras","title":"Features - README","doc":"The following list is the current supported protocols/behaviors and helpers:\n\n- Modbus RTU:\n  - Master\n  - Slave\n  - Framer\n\n- Modbus TCP:\n  - Client\n  - Server\n\n- Helpers:\n  - IEEE754 Float support\n  - Endianess","ref":"readme.html#features"},{"type":"extras","title":"Installation - README","doc":"The package can be installed by adding `modbux` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:modbux, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - README","doc":"***","ref":"readme.html#usage"},{"type":"extras","title":"Modbus RTU - README","doc":"Modbus RTU is an open serial protocol derived from the Master/Slave architecture originally developed by Modicon. This protocol primarily uses an RS-232 or RS-485 serial interfaces for communications.\n\n#### Slave\n\nTo start a Modbus RTU Slave process use `start_link/1`.\n\nThe following options are available:\n- `tty` - defines the serial port to spawn the Slave.\n- `gen_opts` - defines extra options for the Genserver OTP configuration.\n- `uart_opts` - defines extra options for the UART configuration.\n- `model` - defines the DB initial state.\n- `active` - (`true` or `false`) enable/disable DB updates notifications (mailbox).\n\nThe messages (when active mode is `true`) have the following form:\n```elixir\n  {:modbus_rtu, {:slave_request, payload}}\n```\nor\n\n```elixir\n  {:modbus_rtu, {:slave_error, payload, reason}}\n```\n\nThe following are some reasons:\n\n* `:ecrc`  - corrupted message (invalid crc).\n* `:einval`  - invalid function.\n* `:eaddr`  - invalid memory address requested.\n\n#### Model (DB)\n\nThe model or data base (DB) defines the slave/server memory map, the DB is defined by the following syntax:\n```elixir\n%{slave_id => %{{memory_type, address_number} => value}}\n```\nwhere:\n* `slave_id` - specifies a unique unit address from 1 to 247.\n* `memory_type` - specifies the memory between:\n    * `:c` - Discrete Output Coils.\n    * `:i` - Discrete Input Contacts.\n    * `:ir` - Analog Input Registers.\n    * `:hr` - Analog Output Registers.\n* `address_number` - specifies the memory address.\n* `value` - the current value from that memory.","ref":"readme.html#modbus-rtu"},{"type":"extras","title":"Example - README","doc":"```elixir\n# DB inital state\nmodel = %{\n    80 => %{\n      {:c, 1} => 1,\n      {:c, 2} => 0,\n      {:i, 1} => 1,\n      {:i, 2} => 1,\n      {:ir, 1} => 0,\n      {:ir, 2} => 1,\n      {:hr, 1} => 102,\n      {:hr, 2} => 103\n    }\n  }\n# Starts the Slave at \"ttyUSB0\"\n{:ok, s_pid} = Modbux.Rtu.Slave.start_link(tty: \"ttyUSB0\", model: model, active: true)\n```\nif needed, the Slave DB can be modified in runtime with elixir code by using `request/2`,\na `cmd` must be used to update the DB, the `cmd` is a 4 elements tuple, as follows:\n  - `{:rc, slave, address, count}` read `count` coils.\n  - `{:ri, slave, address, count}` read `count` inputs.\n  - `{:rhr, slave, address, count}` read `count` holding registers.\n  - `{:rir, slave, address, count}` read `count` input registers.\n  - `{:fc, slave, address, value}` force single coil.\n  - `{:phr, slave, address, value}` preset single holding register.\n  - `{:fc, slave, address, values}` force multiple coils.\n  - `{:phr, slave, address, values}` preset multiple holding registers.\n\n#### Master\n\nTo start a Modbus RTU Master process use `start_link/1`.\n\nThe following options are available:\n\n  * `tty` - defines the serial port to spawn the Master.\n  * `timeout` - defines slave timeout.\n  * `active` - (`true` or `false`) specifies whether data is received as\n      messages (mailbox) or by calling `request/2`.\n  * `gen_opts` - defines extra options for the Genserver OTP configuration.\n  * `uart_opts` - defines extra options for the UART configuration (defaults:\n        [speed: 115200, rx_framing_timeout: 1000]).\n\nThe messages (when active mode is true) have the following form:\n```elixir\n  {:modbus_rtu, {:slave_response, cmd, values}}\n```\nor\n```elixir\n  {:modbus_rtu, {:slave_error, payload, reason}}\n```\nThe following are some reasons:\n\n  * `:ecrc`  - corrupted message (invalid crc).\n  * `:einval`  - invalid function.\n  * `:eaddr`  - invalid memory address requested.\n\nuse `request/2` to send a `cmd` (command) to a Modbus RTU Slave.","ref":"readme.html#example"},{"type":"extras","title":"Example - README","doc":"```elixir\n# Starts the Master at \"ttyUSB1\" (in the example is connected to ttyUSB1)\n{:ok, m_pid} = Modbux.Rtu.Master.start_link(tty: \"ttyUSB1\")\n# Read 2 holding registers at 1 (memory address) from the slave 80\nresp = Modbux.Rtu.Master.request(m_pid, {:rhr, 80, 1, 2})\n# resp == {:ok, [102, 103]}\n```","ref":"readme.html#example"},{"type":"extras","title":"Modbux TCP - README","doc":"Modbus TCP (also Modbus TCP/IP) is simply the Modbus RTU protocol with a TCP interface that runs on a network.\n\n#### Server\n\nTo start a Modbus TCP Server process use `start_link/1`.\n\nThe following options are available:\n\n  * `port` - is the Modbux TCP Server tcp port number.\n  * `timeout` - is the connection timeout.\n  * `model` - defines the DB initial state.\n  * `sup_otps` - server supervisor OTP options.\n  * `active` - (`true` or `false`) enable/disable DB updates notifications (mailbox).\n\nThe messages (when active mode is true) have the following form:\n```elixir\n  {:modbus_tcp, {:slave_request, payload}}\n```","ref":"readme.html#modbux-tcp"},{"type":"extras","title":"Example - README","doc":"```elixir\n# DB initial state\nmodel = %{80 => %{{:c, 20818} => 0, {:hr, 20818} => 0}}\n# Starts the Server at tcp port: 2000\nModbux.Tcp.Server.start_link(model: model, port: 2000)\n```\n\n#### Client \n\nTo start a Modbus TCP Client process use `start_link/1`.\n\nThe following options are available:\n\n  * `ip` - is the internet address of the desired Modbux TCP Server.\n  * `tcp_port` - is the desired Modbux TCP Server tcp port number.\n  * `timeout` - is the connection timeout.\n  * `active` - (`true` or `false`) specifies whether data is received as\n      messages (mailbox) or by calling `confirmation/1` each time `request/2` is called.\n\nThe messages (when active mode is true) have the following form:\n\n```elixir\n  {:modbus_tcp, cmd, values}\n```\n\nto connect to a Modbus TCP Server `connect/1`.\n\nUse `request/2` to send a `cmd` (command) to a Modbus TCP Server and `confirmation/1` to parse the server response.","ref":"readme.html#example"},{"type":"extras","title":"Example - README","doc":"```elixir\n# Starts the Client that will connect to a Server with tcp port: 2000\n{:ok, cpid} = Modbux.Tcp.Client.start_link(ip: {127,0,0,1}, tcp_port: 2000, timeout: 2000)\n# Connect to the Server\nModbux.Tcp.Client.connect(cpid)\n# Read 1 coil at 20818 from the device 80\nModbux.Tcp.Client.request(cpid, {:rc, 0x50, 20818, 1})\n# Parse the Server response\nresp = Modbux.Tcp.Client.confirmation(cpid) \n# resp == {:ok, [0]}\n```","ref":"readme.html#example"},{"type":"extras","title":"Helpers - README","doc":"#### IEEE754 Float\n\nSeveral modbus register use IEEE754 float format, therefore this library also provides functions to encode and decode data.","ref":"readme.html#helpers"},{"type":"extras","title":"Example - README","doc":"```elixir\n  # Encode\n  +5.0 = Modbux.IEEE754.from_2_regs(0x40a0, 0x0000, :be)\n  [-5.0, +5.0] = Modbux.IEEE754.from_2n_regs([0xc0a0, 0x0000, 0x40a0, 0x0000], :be)\n  # Decode\n  [0xc0a0, 0x0000] = Modbux.IEEE754.to_2_regs(-5.0)\n  [0xc0a0, 0x0000, 0x40a0, 0x0000] = Modbux.IEEE754.to_2n_regs([-5.0, +5.0])\n```\n\nBased on https://www.h-schmidt.net/FloatConverter/IEEE754.html.\n\n#### Endianess\n\nDepending on the device / server the data can be encoded with different types of endianess, therefore this library also provides functions to encode data.","ref":"readme.html#example"},{"type":"extras","title":"Example - README","doc":"```elixir\n  # Encode\n  2.3183081793789774e-41 = Modbux.IEEE754.from_2_regs(0x40a0, 0x0000, :le)\n  [6.910082987278538e-41, 2.3183081793789774e-41] = Modbux.IEEE754.from_2n_regs([0xc0a0, 0x0000, 0x40a0, 0x0000], :le)\n```\n\n\nGood to know:\n- [Erlang default endianess is BIG](http://erlang.org/doc/programming_examples/bit_syntax.html#Defaults)\n- [MODBUS default endianess is BIG (p.34)](http://modbus.org/docs/PI_MBUS_300.pdf)\n- [MODBUS CRC endianess is LITTLE (p.16)](http://modbus.org/docs/PI_MBUS_300.pdf)","ref":"readme.html#example"},{"type":"extras","title":"Documentation - README","doc":"The docs can be found at [https://hexdocs.pm/modbux](https://hexdocs.pm/modbux).\n\nBased on:\n\n- http://modbus.org/docs/PI_MBUS_300.pdf\n- http://modbus.org/docs/Modbux_Messaging_Implementation_Guide_V1_0b.pdf\n- http://modbus.org/docs/Modbux_over_serial_line_V1_02.pdf\n- http://www.simplymodbus.ca/index.html","ref":"readme.html#documentation"},{"type":"extras","title":"Contributing - README","doc":"* Fork our repository on github.\n  * Fix or add what is needed.\n  * Commit to your repository.\n  * Issue a github pull request (fill the PR template).","ref":"readme.html#contributing"},{"type":"extras","title":"License - README","doc":"See [LICENSE](https://github.com/valiot/modbux/blob/master/LICENSE).","ref":"readme.html#license"},{"type":"extras","title":"TODO - README","doc":"* Add Modbux ASCII.\n  * Add Modbux UDP.\n  * Add more examples.\n  * Improve error handling.","ref":"readme.html#todo"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}